import * as wjCore from 'wijmo/wijmo';
import * as wjInput from 'wijmo/wijmo.input';
import * as wjGrid from "wijmo/wijmo.grid"
import * as wjSheet from "wijmo/wijmo.grid.sheet"

import { Component, Inject, OnInit,ViewChild } from '@angular/core';
import { FormGroup, FormBuilder, Validators } from '@angular/forms';
import { Observable } from 'rxjs/Observable'
import { DataSvc } from './services/DataSvc';
import 'rxjs/Rx'; // includes all operators
// import * as wjPdf from "wijmo/wijmo.pdf";
// import * as wjGridPdf from "wijmo/wijmo.grid.pdf";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  //changeDetection: ChangeDetectionStrategy.Default
})
export class AppComponent  {
   public data;
   constructor(@Inject( DataSvc) _dataSvc:DataSvc){
        this.data =_dataSvc.getData(10);
   }
   public selectedRows=[];
   @ViewChild('flex') flex:wjSheet.FlexSheet;
   ngAfterViewInit(){
     
       var _col=new wjGrid.Column();
       _col.header="Select";
       _col.dataType=wjCore.DataType.Boolean;
      /// add column in FlexSheet to get Selected Rows
       this.flex.columns.push(_col);
       // catch the CheckBox click for added Column
       this.flex.hostElement.addEventListener('mousedown',(e:MouseEvent)=>{
        let _htTest= this.flex.hitTest(e); 
        let _target=<HTMLElement>(e.target);         
         if(_target.tagName=="INPUT" && _htTest.col==this.flex.columns.length-1 ){
            let _targetTag=<HTMLInputElement>_target;
            if(_targetTag.type=="checkbox"){              
              this.selectedRows[_htTest.row]=_targetTag.checked;   
              console.log(this.selectedRows) ;
              this.selectedRows.forEach((item,index)=>{
                console.log(item,index);
              })         
            }
         }
       });
   }
  
}
